SET QUOTED_IDENTIFIER ON;


-- Note: this is still used on project creation.  DatabaseImpl uses this
-- to import the starting schema

CREATE TABLE spt_trigger (
    id integer IDENTITY PRIMARY KEY,
    code varchar(256),
    class_name varchar(256),
    script_path varchar(256),
    title varchar(256),
    description character varying(max),
    event varchar(256),
    mode varchar(256),
    process varchar(256),
    listen_process varchar(256),
    trigger_type varchar(256),
    data character varying(max),
    "timestamp" datetime2(6) DEFAULT (getdate()),
    search_type varchar(256),
    s_status varchar(256),
    CONSTRAINT "spt_trigger_code_idx" UNIQUE (code)
);


CREATE TABLE widget_config (
    id integer IDENTITY PRIMARY KEY,
    code character varying(256),
    "view" character varying(256),
    category character varying(256),
    search_type character varying(256),
    "login" character varying(256),
    config character varying(max),
    "timestamp" datetime2(6) DEFAULT (getdate()),
    s_status character varying(32),
    CONSTRAINT "widget_config_code_idx" UNIQUE (code)
);


CREATE TABLE naming (
    id integer IDENTITY PRIMARY KEY,
    search_type character varying(100),
    dir_naming character varying(max),
    file_naming character varying(max),
    sandbox_dir_naming character varying(max),
    snapshot_type character varying(256),
    context character varying(256),
    code character varying(256),
    latest_versionless BIT,
    current_versionless BIT,
    manual_version BIT,
    ingest_rule_code character varying(256),
    "condition" character varying(max),
    class_name character varying(max), 
    script_path character varying(max),
    CONSTRAINT "naming_code_idx" UNIQUE (code)
);



CREATE TABLE prod_setting (
    id integer IDENTITY PRIMARY KEY,
    code character varying(256),
    "key" character varying(100),
    value character varying(max),
    description character varying(max),
    "type" character varying(30),
    search_type character varying(200),
    category character varying(256),
    CONSTRAINT "prod_setting_code_idx" UNIQUE (code),
    CONSTRAINT "prod_setting_key_idx" UNIQUE ("key")
);



CREATE TABLE custom_script (
    id integer IDENTITY PRIMARY KEY,
    code character varying(256),
    title character varying(256),
    description character varying(max),
    folder character varying(1024),
    script character varying(max),
    "login" character varying(256),
    "timestamp" datetime2(6) DEFAULT (getdate()),
    language character varying(256),
    s_status character varying(256),
    CONSTRAINT "custom_script_code_idx" UNIQUE (code)
);


CREATE TABLE spt_url (
    id integer IDENTITY PRIMARY KEY,
    code varchar(256),
    url varchar(256),
    widget character varying(max),
    description character varying(max),
    "timestamp" datetime2(6) DEFAULT (getdate()),
    s_status varchar(256),
    CONSTRAINT "url_code_idx" UNIQUE (code)
);


CREATE TABLE spt_client_trigger (
    id integer IDENTITY PRIMARY KEY,
    code character varying(256),
    event character varying(256),
    callback character varying(256),
    description character varying(max),
    "timestamp" datetime2(6) DEFAULT (getdate()),
    s_status character varying(32),
    CONSTRAINT "client_trigger_code_idx" UNIQUE (code)
);



CREATE TABLE spt_process (
    id integer IDENTITY PRIMARY KEY,
    code varchar(256),
    pipeline_code varchar(256),
    process varchar(256),
    color varchar(256),
    sort_order integer,
    "timestamp" datetime2(6) DEFAULT (getdate()),
    s_status varchar(256),
    checkin_mode character varying(max), 
    subcontext_options character varying(max), 
    checkin_validate_script_path character varying(max), 
    checkin_options_view character varying(max), 
    sandbox_create_script_path character varying(max), 
    context_options character varying(max), 
    description character varying(max), 
    repo_type varchar(256), 
    transfer_mode varchar(256),
    CONSTRAINT "process_code_idx" UNIQUE (code)
);


